//------------------------------------------------------------------------------ 
//      Copyright (c) 2004, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:   2chPositive.h
//      Author:      Be Nanashi-San 
//      Description: 2chPositive application class. 
//------------------------------------------------------------------------------
#ifndef NICHPOSITIVE_H_INCLUDED
#define NICHPOSITIVE_H_INCLUDED

#include <Application.h>
#include <Font.h>
#include <String.h>
#include "TSettings.h"

//Conection Mode
const bool	kONLINE = false;
const bool	kOFFLINE = true;

class mainWindow;
class FindWindow;
class JumpWindow;
class PrefWindow;
class ThreadWriteWindow;
//class BPath; 20060416
class BBSHandler;
class BPopUpMenu;

class a2chViewer : public BApplication 
{
public:
	a2chViewer();

//20060415
//	inline void SetConectionMode(bool state){fConection = state;}
//	inline bool ConectionMode(){return fConection;}
//	inline TSettings *Settings() {return &fSettings;} 

	status_t Alert();
	status_t OffLineAlert();

	//Reader
	BBSHandler * CurReader();
	void MakeReaderList(BPopUpMenu *aMenu);
	void SetCurReader(const char *name);

private:
	bool QuitRequested();
	void MessageReceived(BMessage *message);
	void RefsReceived(BMessage *message);
	void AboutRequested();
	void OpenFindWindow();
	void OpenJumpWindow();
	void DoFind(BMessage *message, bool findagain);
	void OpenPreference();
	void OpenWriteThreadWindow(BMessage *message);

	//Reader
	void LoadReader();
	void ReleaseReader();

	void MakeSettingDir();
	void MakeDefault();
	void NotImplemented();
//20060415
//	bool fConection;
	TSettings *fSettings;
	
	mainWindow *fMainWindow;
	FindWindow *fFindWindow;
	JumpWindow *fJumpWindow;
	PrefWindow *fPrefWindow;
	ThreadWriteWindow *fWriteWindow;
	int32 fTarget;
	BString fFindString;
	BList *fReaderList;
//	BList *fReaderNameList;
	BBSHandler *fCurReader;
	
	BFont fBoardFont; 
	BFont fThreadListFont;
	BFont fThreadFont;
	int32 fThreadDisplayWidth;
	int32 fThreadDisplayType;
};


#endif //NICHPOSITIVE_H_INCLUDED
