//------------------------------------------------------------------------------ 
//      Copyright (c) 2004, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:   BBS2chReader.cpp
//      Author:      Be Nanashi-San 
//      Description: BBS Board list display class. 
//------------------------------------------------------------------------------
#include <OutlineListView.h>
#include <Directory.h>
#include <Entry.h>
#include <File.h>
#include <DataIO.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "BoardItem.h"
#include "BBS2chReader.h"
#include "NetUtil.h"
#include "Util.h"
#include "2chPositive.h"
#include "setting.h"

static const unsigned int kNAMEBUFSIZ = 256;

////////////////////////////////////////////////////////////////////////////////
// 
//
//
////////////////////////////////////////////////////////////////////////////////
BBS2chReader::BBS2chReader()
:BBSHandler("２ちゃんねる")
{
}
////////////////////////////////////////////////////////////////////////////////
// 
//
//
////////////////////////////////////////////////////////////////////////////////
BBS2chReader::~BBS2chReader()
{
}

////////////////////////////////////////////////////////////////////////////////
// 
//
//
////////////////////////////////////////////////////////////////////////////////
status_t
BBS2chReader::BoardRequested(BMallocIO &buf)
{
	buf.Seek(0, SEEK_SET);
	return this->defaultReader(buf, "menu.2ch.net", true);
}
////////////////////////////////////////////////////////////////////////////////
// 
//
//
////////////////////////////////////////////////////////////////////////////////
void
BBS2chReader::DrawBoardListReuested(BoardListView *owner, BMallocIO &buf)
{
	const char *s = static_cast<const char *>(buf.Buffer());
	size_t size = buf.BufferLength();
	this->defaultDrawer(owner, s, size, NULL, "大人の時間");
}
