#ifndef _BASE2chTextView_
#define _BASE2chTextView_
//-------------------------------------------------------------------------------------------------------
//      Copyright (c) 2005, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:   	Base2chTextView.h
//      Author:      	Be Nanashi-San@598 in "BeOS - Zeta R4" Thread 
//						(http://pc8.2ch.net/test/read.cgi/os/1120676818/598)
//		Description:	互換Base2chTextView.
//-------------------------------------------------------------------------------------------------------

#include <TextView.h>
#include <Window.h>
#include <vector>
#include "MUtils.h"

const uint32 kMSG_BORN_BABY	= 'Baby';
const uint32 kMSG_THREAD_END = 'Tend';
const uint32 kMSG_EXITED_VIEW = 'Vout';
const uint32 kMSG_MOUSE_UP = 'Mup ';
const uint32 kMSG_MOUSE_CLICK = 'Sclk';
const uint32 kMSG_GOOGLE = 'Ggle';
const uint32 kMSG_COPY_LOCATION = 'Clca';
const uint32 kMSG_COPY_THREAD = 'Cthd';
const uint32 kMSG_RELOAD = 'Trld';

class BPopUpMenu;
class Base2chTextView : public BTextView
{
	public:
		Base2chTextView(BRect frame, const char *name,
					 BRect textRect,
					 uint32 resizingMode = B_FOLLOW_ALL,
					 uint32 flags = B_WILL_DRAW);
		virtual ~Base2chTextView(); 
		void AttachedToWindow();
		void FrameResized(float width, float height);
		void MessageReceived(BMessage *msg);
		void MouseDown(BPoint where);
		void MouseUp(BPoint where);
		void MouseMoved(BPoint where, uint32 code, const BMessage *msg);
		void Pulse();
		void ScrollTo(BPoint point);
		inline void	ScrollTo(float x, float y) { ScrollTo(BPoint(x, y)); };


		void SetInvoke(const char *name, int32 length);
		void Launcher(const char *type, const char *param);
		virtual	void PostStatus(const char *title);
		void SelectionInvoke();
		status_t Invoke();		
		void HtmlParser(const char *text);
	
	protected:
		MActionList	fAction;
		BPoint fMousePoint;
		BPoint fStatic_where;
		vector<int32> fThread;
		
	private:
		void InsertThread(int32 i, Base2chTextView *outView);
		void SetInvoke(const char *name, int32 size, int32 length);
		void InvokeThread(int32 thread_no);
		void PrintToStream(int32 flags = 0);
		int32 is_number(int32 offset);
		int32  fCountTimer;
		int32  fCursorOffset;
};

#endif
