//------------------------------------------------------------------------------ 
//      Copyright (c) 2004, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:   BoardListView.h
//      Author:      Be Nanashi-San 
//      Description: BBS Board list display class. 
//------------------------------------------------------------------------------

#ifndef BOARDLISTVIEW_H_INCLUDED
#define BOARDLISTVIEW_H_INCLUDED

#include <View.h>
//#include <String.h>
class BMessage;
class BRect;
class BFile;
class BoardOutLineListView;
class BMenuField;
class BBSHandler;

class BoardListView : public BView 
{
public:
	BoardListView(BRect frame); 
	virtual ~BoardListView();
	void AttachedToWindow();
	void MessageReceived (BMessage * msg);
	BoardOutLineListView *OutLineView();
	
private:
	status_t SetBBS (bool forceRemote = false);
	void BBSChanged (BMessage * message);
	void StopDrawing();

	BoardOutLineListView *fOutLineView;
	int32 fBBSindex;
	BBSHandler *fCureader;

	class Reader;
	friend class BoardListView::Reader; /* gcc3 fix*/
	sem_id fStopSem;
	bool fStopLoading;
	thread_id fThread;
	friend class BBSHandler;
	 
	class Reader
	{
	public:
		Reader(BoardListView *view, sem_id sem);
		static status_t Run(void *);

	private:
		bool Lock();
		status_t Unlock();
		BoardListView *fView;
		sem_id fStopSem;
	};
};

#endif //BOARDLISTVIEW_H_INCLUDED
