//------------------------------------------------------------------------------ 
//      Copyright (c) 2004, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:   BoardOutLineListView.h
//      Author:      Be Nanashi-San 
//      Description: BBS Board list display class. 
//------------------------------------------------------------------------------

#ifndef BOARDOUTLINEVIEW_H_INCLUDED
#define BOARDOUTLINEVIEW_H_INCLUDED

#include <OutlineListView.h>
class BMessage;
class BRect;
class BFile;
class BoardItem;

class BoardOutLineListView : public BOutlineListView 
{
public:
	BoardOutLineListView(BRect frame); 
	virtual ~BoardOutLineListView();
	void AttachedToWindow();
	void MessageReceived (BMessage * msg);
	bool InitiateDrag(BPoint point, int32 index, bool wasSelected);
	int32 FindBoardName(const char *find);
	int32 FindBoardUri(const char *find);
	bool CurrentQuery(BMessage *query);
	void OpenBookmark(BMessage *message);

	void ItemInvoked(BMessage *message);
	void ExpandOrCollaspse(bool expand);
	void DragActionCopy(BMessage * request);
private:

	BoardItem *fSeletion;
	//BString fBBSfilename;
};

#endif //BOARDOUTLINEVIEW_H_INCLUDED
