//------------------------------------------------------------------------------ 
//      Copyright (c) 2004, Be Nanashi-San@757 in "Zeta 2" Thread
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:   Bookmark2ch.h
//      Author:      Be Nanashi-San@757 in "Zeta 2" Thread  
//                   (http://pc5.2ch.net/test/read.cgi/os/1070354122/757) 
//      Description: Bookmark functions 
//------------------------------------------------------------------------------
#ifndef		_BOOKMARK_
#define		_BOOKMARK_

#include <Path.h>
#include <Messenger.h>
class BMenu;
struct entry_ref;

class Bookmark2ch
{
public:
	Bookmark2ch(BMenu *menu, BMessenger report);
	~Bookmark2ch();
	void WatchMessage(BMessage *msg);
	void AddBookmark(BMessage *msg);
	
	BMenu* Ref2Menu(entry_ref *ref);
	void SyncMenu(entry_ref *ref, BMenu *menu);
	void DeleteMenu(const char *label, BMenu *menu);
	
private:
	BPath fPath;
	BMenu* fMenu;
	BMessenger fReport;
};

void AddBookmarkAttr(BString *url, BString *title, BFile *file);

#endif
