#ifndef		_Cashe_
#define		_Cashe_
//-------------------------------------------------------------------------------------------------------
//      Copyright (c) 2005, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:   	Cashe.h
//      Author:      	Be Nanashi-San
//
//		Description:	スレ表示用キャッシュ
//-------------------------------------------------------------------------------------------------------

#include	<TextView.h>

class K2chTextView;
class MStyle;

class TextRunArray {
	public:
		TextRunArray(size_t entries);
		~TextRunArray();

		text_run_array &Array() { return *fArray; }
		size_t MaxEntries() const { return fNumEntries; }

	private:
		text_run_array *fArray;
		size_t fNumEntries;
};

class Cashe
{
	public:
		Cashe();
		~Cashe();
		void Insert(char *text, MStyle *style);
		void Insert(char *text, int32 length, MStyle *style);
		void Flash(K2chTextView *outView);
	private:
		void Init();
		
		char *fBuf;
		//vector<int32> fOffsets;
		int32 fBufferLength;
		int32 fLength;
		TextRunArray *fRunArray;
		int32 fStyleBufferLength;
		int32 fStyleLength;
};

#endif //_Cashe_
