//------------------------------------------------------------------------------ 
//      Copyright (c) 2004, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:   DisplayThreadView.h
//      Author:      Be Nanashi-San 
//      Description: 	 
//------------------------------------------------------------------------------

#ifndef DISPLAYTHREADVIEW_H_INCLUDED
#define DISPLAYTHREADVIEW_H_INCLUDED

#include <View.h>
class BFile;
class BDirectory;
class K2chTextView;

class DisplayThreadView : public BView {
public:
	DisplayThreadView(BRect frame);
	~DisplayThreadView();
	void MessageReceived (BMessage * msg);
	void WindowActivated(bool active);
	void Draw(BRect updateRect);

private:
	void DisplayThread(bool uselocal);
	status_t LoadLocalDat(BFile *file);
	status_t LoadDatFromINet(BFile *file);
	void JumpToRes(int32 resno);
	
	K2chTextView *fText;
	BMessage *fCurrentMessage;
	off_t	fCurrentEOF;
};

#endif // DISPLAYTHREADVIEW_H_INCLUDED
