#include <Message.h>
#include <Messenger.h>
#include <Screen.h>
#include "K2chTipTextView.h"
#include "MSticker.h"


const uint32 kMSG_HIDE = 'Hide';


////////////////////////////////////////////////////////////////////////////////
// MBackGrounds
//
//
////////////////////////////////////////////////////////////////////////////////
MBackGrounds::MBackGrounds(BRect frame, const char *name, uint32 resizingMode, uint32 flags)
: BView(frame, name, resizingMode, flags|B_FULL_UPDATE_ON_RESIZE)
{
		SetViewColor(B_TRANSPARENT_COLOR);
}
////////////////////////////////////////////////////////////////////////////////
// MBackGrounds
//
//
////////////////////////////////////////////////////////////////////////////////
void
MBackGrounds::Draw(BRect /*updtRect*/)
{
	const uint8 data[] = {250, 247, 238, 229, 210, 200 };
	SetDrawingMode(B_OP_MIN);
	BRect frame(Bounds());
	for (int32 i = 0; i < 6; i++) {
		BView::SetHighColor(data[i], data[i], data[i], 198);
		BView::StrokeRoundRect(frame, 6 - i, 6 - i);
		frame.InsetBy(1, 1);
	}
	frame.InsetBy(-1, -1);
	frame.SetLeftTop(BPoint(0, 0));
	BView::SetDrawingMode(B_OP_COPY);
	BView::StrokeRect(frame);
}

////////////////////////////////////////////////////////////////////////////////
// MSticker
//
//
////////////////////////////////////////////////////////////////////////////////
MSticker::MSticker(BRect frame, K2chTipTextView *fView)
	: BWindow(frame, "TipWindow", B_NO_BORDER_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL, 0)
	, fDragCount(0)
{
	if (!fView)	return;
	
	BWindow::ResizeBy(7, 7);
	MBackGrounds *backView = new MBackGrounds(Bounds(), "MSticker:backgrounds", B_FOLLOW_ALL, B_WILL_DRAW);
	fView->MoveTo(1, 1);
	backView->AddChild(fView);
	this->AddChild(backView);
	fTextView = fView;
}

////////////////////////////////////////////////////////////////////////////////
// MessageReceived
//
//
////////////////////////////////////////////////////////////////////////////////
void
MSticker::MessageReceived(BMessage *msg)
{
	switch (msg->what) {
	case kMSG_EXITED_VIEW:
		//if (fDragCount == 0){
		BWindow::Hide();
		//}
		break;

	case kMSG_MOUSE_DOWN_MOVE:
		//this->MoveBy(msg->FindPoint("point"));
		//fDragCount = 3;
		break;

	case kMSG_MOUSE_UP:
		//if (fDragCount & 1) {
		//	BWindow::ResizeBy(-7, -7);
		//	snooze(50000);	/* backgroundが再描画される機会を与える。時間(50000)に根拠なし */
		//	BWindow::ResizeBy(+7, +7);
		//} else if (IsFront()){
			BWindow::Hide();
		//}
		//fDragCount &= 0xfffffffe;
		break;

//	case kMSG_HIDE:
//		BWindow::Hide();
//		break;
	default:
		BWindow::MessageReceived(msg);
	}
}
////////////////////////////////////////////////////////////////////////////////
// Show
//
//
////////////////////////////////////////////////////////////////////////////////
void
MSticker::ShowSticker(BPoint point)
{
	BRect scrRect = BScreen().Frame();
	BWindow::MoveTo(point.x, point.y - (Frame().Height() - 32));
	if (!scrRect.Contains(Frame())) {
		/* 未実装 */
	}
	BWindow::Show();
}
