//------------------------------------------------------------------------------ 
//      Copyright (c) 2005, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:	PrefWindow.h
//      Author: 	Be Nanashi-San 
//      Description:	 
//------------------------------------------------------------------------------
#ifndef PREF_WINDOW_H_INCLUDED
#define PREF_WINDOW_H_INCLUDED

#include <MenuField.h>
#include <TextControl.h>
#include <RadioButton.h>
#include "Dialog.h"

class BTabView;
class PrefWindow : public Dialog 
{
public:
	PrefWindow(); 
	virtual ~PrefWindow(); 
	virtual void MessageReceived(BMessage *message);
	virtual bool QuitRequested();

	void SetMarkeMenuField(BMenuField *target, const char *value);
	void SetTextField(BTextControl *target, const char *value);
	void SetRadioButton(BRadioButton *target, const char *value);

private:
	void DispatchButton(BMessage *msg);
	void ModifiedMessage(BMessage *msg);

	void CloneMessage();
	void DeleteCloneMessage();
	void UpdateMessage(BMessage *msg);
	BMessage* DiffMessage(BMessage *src, BMessage *dst);
	void ButtonEnable(bool flags);
	
	bool fChanged;
	BMessage *fClone;
	BTabView* fTabView;
};

class ConnectionPrefs : public BView 
{
public:
	ConnectionPrefs(BRect frame); 
	virtual ~ConnectionPrefs() {};
	void AttachedToWindow();
};

class DisplayPrefs : public BView 
{
public:
	DisplayPrefs(BRect frame); 
	virtual ~DisplayPrefs() {}; 
	void AttachedToWindow();
};

class CachePrefs : public BView 
{
public:
	CachePrefs(BRect frame); 
	virtual ~CachePrefs() {}; 
	void AttachedToWindow();
};

#endif //PREF_WINDOW_H_INCLUDED
