//------------------------------------------------------------------------------ 
//      Copyright (c) 2004, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:	ThreadListView.h
//      Author: 	Be Nanashi-San 
//      Description:	 
//------------------------------------------------------------------------------

#ifndef THREADLISTVIEW_H_INCLUDED
#define THREADLISTVIEW_H_INCLUDED

//TODO:ZetaやHaikuではOSのColumnListViewを使うようにするか？
//（効用:サイズ縮小。）
#include "ColumnListView.h"

class ThreadListView : public BColumnListView
{
public:
	ThreadListView(BRect rect);
	virtual ~ThreadListView();
	void MessageReceived (BMessage * msg);
	void AttachedToWindow();
	bool CurrentQuery (BMessage *msg);

protected:
	BBitmap * GetPositinArrow(int32 newposition, int32 oldposion);

private:
	void LoadList(bool uselocal = true, const char *datname = NULL);
	void StopLoad();
	status_t LoadSubjectFile(BFile *file);
	status_t LoadSubectFromINet(BFile *file);
		
	void DoFind(BMessage *msg);
	void DoUpdate(BMessage *msg);
	void OpenBoard (BMessage *msg);
	void ListInvoked ();
	BRow* FindRowStringField(const char *label, int32 fieldNo);
		
	void ClearCache();
	void ClearAllCache();
	
	BDirectory *fCacheDir;
	BString fBoardUri;

	BBitmap *fBlueUpArrow;
	BBitmap *fYellowEqaulArrow;
	BBitmap *fRedDownArrow;
	BBitmap *fGrayBall;

	class Reader;
	friend class ThreadListView::Reader; /* gcc3 fix*/
	sem_id fStopSem;
	bool fStopLoading;
	thread_id fThread;

	class Reader
	{
	public:
		Reader(ThreadListView *view, BFile *datfile, const char* datname, sem_id sem);
		static status_t Run(void *);

	private:
		bool Lock();
		status_t Unlock();
		BRow* makeThreadRow(char *title, char *datname, int resnum, int threadposion);

		ThreadListView *fView;
		BFile *fDatFile;
		BString fOpenDatName;
		sem_id fStopSem;
	};
};

#endif //THREADLISTVIEW_H_INCLUDED

