//------------------------------------------------------------------------------ 
//      Copyright (c) 2004, Be Nanashi-San 
// 
//      Permission is hereby granted, free of charge, to any person obtaining a 
//      copy of this software and associated documentation files (the "Software"), 
//      to deal in the Software without restriction, including without limitation 
//      the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//      and/or sell copies of the Software, and to permit persons to whom the 
//      Software is furnished to do so, subject to the following conditions: 
// 
//      The above copyright notice and this permission notice shall be included in 
//      all copies or substantial portions of the Software. 
// 
//      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
//      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//      FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//      DEALINGS IN THE SOFTWARE. 
// 
//      File Name:	settting.h
//      Author: 	Be Nanashi-San 
//      Description:	Key string for get/set setting. 
//------------------------------------------------------------------------------
#ifndef SETTING_H_INCLUDED
#define SETTING_H_INCLUDED

const char* const kSETTING_FILE = "/boot/home/config/settings/2chPositive/settings";
const char* const kSETTING_PATH = "/boot/home/config/settings/2chPositive/";
const char* const kBBS_DIR_NAME = "BBS";
const char* const kCACHE_DIR_NAME = "2chCache";
const char* const kBOOKMARK_DIR_NAME = "2chPositive/Bookmarks";

//メインウインドウの位置とサイズ
const char* const kSETTING_WINDOW_RECT = "WindowRect";
//スプリッターの位置
const char* const kSETTING_H_SPLITTER_POINT = "HPos";
const char* const kSETTING_V_SPLITTER_POINT = "VPos";
//ThreadListの設定
const char* const kSETTING_THREADLIST = "ThreadList";
//使用するBBSの名前と板一覧の場所
const char* const kSETTING_BBS_NAME = "BBSName";
const char* const kSETTING_BBS_SOURCE = "BBSSource";

const char* const kSETTING_OFFLINE = "OffLine";

//20060511:PrefWindow.hより
const char* const DISPLAY_BOARD_FONT_NAME = "board_font_name";
const char* const DISPLAY_BOARD_FONT_SIZE = "board_font_size";
const char* const DISPLAY_RESLIST_FONT_NAME = "reslist_font_name";
const char* const DISPLAY_RESLIST_FONT_SIZE = "reslist_font_size";
const char* const DISPLAY_RES_FONT_NAME = "res_font_name";
const char* const DISPLAY_RES_FONT_SIZE = "res_font_size";

const char* const DISPLAY_ALL_THREAD = "res_disp_all";
const char* const DISPLAY_FIRST_THREAD = "res_disp_first";
const char* const DISPLAY_LAST_THREAD = "res_disp_last";
const char* const DISPLAY_THREAD_RANGE = "res_disp_range";

const char* const GENERAL_CHANNEL = "BBSName";
const char* const GENERAL_LINKPROXY = "linkproxy";
const char* const GENERAL_BBSURL = "BBSSource";
const char* const GENERAL_PROXY = "proxy";
const char* const GENERAL_PORT = "port";

#endif //SETTING_H_INCLUDED
